package Controllers.BonLivraisonClt;

import Models.BonLivraisonClt.BonLivraisonCltDB;
import Models.BonLivraisonClt.BonLivraisonCltGestionList;
import com.gluonhq.charm.glisten.control.ProgressBar;
import java.io.IOException;

import java.net.URL;
import java.util.ResourceBundle;
import javafx.beans.value.ChangeListener;
import javafx.beans.value.ObservableValue;

import javafx.collections.FXCollections;
import javafx.collections.ObservableList;
import javafx.concurrent.Service;
import javafx.concurrent.Task;
import javafx.concurrent.WorkerStateEvent;
import javafx.event.ActionEvent;
import javafx.event.EventHandler;
import javafx.fxml.FXML;
import javafx.fxml.FXMLLoader;
import javafx.fxml.Initializable;
import javafx.scene.Group;
import javafx.scene.Node;
import javafx.scene.control.Button;
import javafx.scene.control.ChoiceBox;
import javafx.scene.control.DatePicker;
import javafx.scene.control.Label;
import javafx.scene.control.TableCell;
import javafx.scene.control.TableColumn;
import javafx.scene.control.TableView;
import javafx.scene.control.TextField;
import javafx.scene.control.cell.PropertyValueFactory;
import javafx.scene.image.Image;
import javafx.scene.image.ImageView;
import javafx.scene.input.KeyCode;
import javafx.scene.input.KeyEvent;
import javafx.scene.input.MouseEvent;
import javafx.scene.layout.AnchorPane;
import javafx.scene.text.Text;
import javafx.util.Callback;

/**
 *
 * @author maher
 */
public class BonLivraisonCltGestionController implements Initializable {

    @FXML private AnchorPane PaneBonLivraisonCltGestion;
    
    @FXML private ProgressBar ProgressBarBonLivraisonClt;
    
    @FXML private Button ButtonSearchBonLivraisonClt;
            
    @FXML public TableView<BonLivraisonCltGestionList> TableViewBonLivraisonCltListGestion;
    @FXML public TableColumn<BonLivraisonCltGestionList ,String> TabColIdBonLivrasionClt;
    @FXML public TableColumn<BonLivraisonCltGestionList ,String> TabColDateHeurLivraison ;
    @FXML public TableColumn<BonLivraisonCltGestionList ,String> TabColAdresseLivraison;
    @FXML public TableColumn<BonLivraisonCltGestionList ,String> TabColCodeClt;
    @FXML public TableColumn<BonLivraisonCltGestionList ,String> TabColIdFactureClt ;
    @FXML public TableColumn<BonLivraisonCltGestionList ,String> TabColTransporteur;
    @FXML public TableColumn<BonLivraisonCltGestionList ,Boolean>TabColBlDetail ;

    @FXML public TextField  TextFieldIdBonLivrasionClt ;
    @FXML public DatePicker DatePickerDateLivraison;
    @FXML public TextField  TextFieldCodeClt;
    @FXML public TextField  TextFieldIdFactureClt;
    @FXML public TextField  TextFieldTransporteur;
    @FXML public TextField  TextFieldAdresseLivraison;
    
    @FXML private AnchorPane ListerPages;
    @FXML private Text ActuellePage ;
    @FXML private Text NbrPage ;
    @FXML private Group nextgroupe ;
    @FXML private Group avancergroupe ;
    @FXML private Group lastgroupe ;        
    @FXML private Group retourgroupe ;
    @FXML private Label LabelCount ;
    @FXML private ChoiceBox NbrLigne ;
    
    private Service<Void> ThreadSearchBonLivraisonClt;
    
    ObservableList cursors = FXCollections.observableArrayList("10","15","20");
    private Integer nbrligne = 10 ;
    private Integer totalcount = 0;
    private Integer nbrpage = 0;
    private Integer actuellepage = 1;
    Integer position = 0;
    
    @Override
    public void initialize(URL url, ResourceBundle rb) {
        
        //comboboxnombre des lignes tableview
        NbrLigne.setItems(cursors);
        NbrLigne.getSelectionModel().selectFirst();
        
        TableViewBonLivraisonCltListGestion.setEditable(true);
        
        TabColIdBonLivrasionClt.setStyle( "-fx-alignment: CENTER;");TabColIdBonLivrasionClt.getStyleClass().add("Center");
        TabColIdBonLivrasionClt.setCellValueFactory(new PropertyValueFactory<BonLivraisonCltGestionList, String>("IdBonLivrasionClt"));
        
        TabColDateHeurLivraison.setStyle( "-fx-alignment: CENTER;");TabColDateHeurLivraison.getStyleClass().add("Center");
        TabColDateHeurLivraison.setCellValueFactory(new PropertyValueFactory<BonLivraisonCltGestionList, String>("DateHeurLivraison"));
        
        TabColAdresseLivraison.setStyle( "-fx-alignment: CENTER;");TabColAdresseLivraison.getStyleClass().add("Center");
        TabColAdresseLivraison.setCellValueFactory(new PropertyValueFactory<BonLivraisonCltGestionList, String>("AdresseLivraison"));
        
        TabColCodeClt.setStyle( "-fx-alignment: CENTER;");TabColCodeClt.getStyleClass().add("Center");
        TabColCodeClt.setCellValueFactory(new PropertyValueFactory<BonLivraisonCltGestionList, String>("CodeClt"));
        
        TabColIdFactureClt.setStyle( "-fx-alignment: CENTER;");TabColIdFactureClt.getStyleClass().add("Center");
        TabColIdFactureClt.setCellValueFactory(new PropertyValueFactory<BonLivraisonCltGestionList, String>("IdFactureClt"));
        
        TabColTransporteur.setStyle( "-fx-alignment: CENTER;");TabColTransporteur.getStyleClass().add("Center");
        TabColTransporteur.setCellValueFactory(new PropertyValueFactory<BonLivraisonCltGestionList, String>("Transporteur"));
        
        TabColBlDetail.setStyle( "-fx-alignment: CENTER;");TabColBlDetail.getStyleClass().add("Center");
        TabColBlDetail.setCellFactory(new Callback<TableColumn<BonLivraisonCltGestionList, Boolean>, TableCell<BonLivraisonCltGestionList, Boolean>>() {
            @Override 
            public TableCell<BonLivraisonCltGestionList, Boolean> call(TableColumn<BonLivraisonCltGestionList, Boolean> personBooleanTableColumn) {
                return new ButtonCell();
            }
        });
        
        
        ButtonSearchBonLivraisonClt.setOnMouseClicked(new EventHandler<MouseEvent>() {
            public void handle(MouseEvent me) {
                SearchBonLivraisonClt();
            }
        });
        
        PaneBonLivraisonCltGestion.setOnKeyPressed(new EventHandler<KeyEvent>() {
            @Override
            public void handle(KeyEvent ke) {
                if (ke.getCode().equals(KeyCode.ENTER)) {
                    SearchBonLivraisonClt();
                }
            }
        });
        
        GestionSearchBonLivraisonClt();
    }
    
    
    @FXML
    private void AjouterBonLivraisonCltButtonAction(ActionEvent event) throws IOException {
        PaneBonLivraisonCltGestion.getChildren().clear();
        PaneBonLivraisonCltGestion.getChildren().add((Node) FXMLLoader.load(getClass().getResource("/Views/BonLivraisonClt/BonLivraisonCltAjouter.fxml")));
    }
    
    
    private class ButtonCell extends TableCell<BonLivraisonCltGestionList, Boolean> {
        final Button cellButton = new Button();
        ButtonCell(){
            cellButton.getStyleClass().add("btn-icon-primary");
            Image coffeeImage = new Image(getClass().getResourceAsStream("/Public/icon/detailbutton.png"));
            ImageView buttonGraphic = new ImageView();
            buttonGraphic.setImage(coffeeImage);
            cellButton.setGraphic(buttonGraphic);
            cellButton.setOnAction(new EventHandler<ActionEvent>(){ //Action when the button is pressed
                @Override
                public void handle(ActionEvent t) {
                    BonLivraisonCltGestionList current = (BonLivraisonCltGestionList) ButtonCell.this.getTableView().getItems().get(ButtonCell.this.getIndex());
                    String IdBonLivrasionClt = current.getIdBonLivrasionClt();
                    
                    BonLivraisonCltDetailController BonLivraisonCltDetail = new BonLivraisonCltDetailController();
                    BonLivraisonCltDetail.Show();
                    BonLivraisonCltDetail.SetIdBonLivraison(IdBonLivrasionClt);
                }
            });
        }
        
        //Display button if the row is not empty
        @Override
        protected void updateItem(Boolean t, boolean empty) {
            if(!empty){
                setGraphic(cellButton);
            } else {
                setGraphic(null);
            }
        }
    }
    
    
    

/******************************************************************************                                                                             *
 *                                                                              *
 *                       Methode last Next TableView client  Entreprise                   *
 * *                                                                            *
 ******************************************************************************/  
    
    private void SearchBonLivraisonClt()
    {
        ProgressBarBonLivraisonClt.setVisible(true);
        
        ButtonSearchBonLivraisonClt.setDisable(true);
        
        ThreadSearchBonLivraisonClt = new Service<Void>(){
            @Override
            protected Task<Void> createTask(){
                return new Task<Void>(){
                    @Override
                    protected Void call() throws Exception{
                        
                        position = 0;
                        
                        actuellepage = 1;
                        
                        String DateLivraison = "";
                        if(DatePickerDateLivraison.getValue() != null){
                            DateLivraison = DatePickerDateLivraison.getValue().toString();
                        }    
                        
                        ObservableList<BonLivraisonCltGestionList> ListBonLivraisonClts = new BonLivraisonCltDB().SearchBonLivraisonCltGestion(
                                                                                        position, 
                                                                                        nbrligne, 
                                                                                        TextFieldIdBonLivrasionClt.getText(), 
                                                                                        DateLivraison,  
                                                                                        TextFieldCodeClt.getText(), 
                                                                                        TextFieldIdFactureClt.getText(), 
                                                                                        TextFieldTransporteur.getText(),
                                                                                        TextFieldAdresseLivraison.getText());
                            
                        TableViewBonLivraisonCltListGestion.setItems(ListBonLivraisonClts);
                        
                        totalcount = new BonLivraisonCltDB().nbrSearchBonLivraisonCltGestion(TextFieldIdBonLivrasionClt.getText(), DateLivraison, TextFieldCodeClt.getText(), TextFieldIdFactureClt.getText(), TextFieldTransporteur.getText(), TextFieldAdresseLivraison.getText());
                        
                        if(totalcount > 0){
                            ActuellePage.setText("1");
                        }else{
                            ActuellePage.setText("0");
                        }
                        
                        if(totalcount % nbrligne==0){ 
                            nbrpage = totalcount / nbrligne ;
                        }
                        else{ 
                            nbrpage = (totalcount / nbrligne) + 1 ; 
                        }
                        NbrPage.setText(Integer.toString(nbrpage));
                        
                        return null;
                    }
                };
            }
	};
        
        ThreadSearchBonLivraisonClt.setOnSucceeded(new EventHandler<WorkerStateEvent>(){
            @Override
            public void handle(WorkerStateEvent event){
                ProgressBarBonLivraisonClt.setVisible(false);
                ButtonSearchBonLivraisonClt.setDisable(false);
                LabelCount.setText(totalcount.toString());
                
            }
        });
        ThreadSearchBonLivraisonClt.start();
    }
    
    
    private void NextLastSearchBonLivraisonClt(Integer ParmPosition, Integer ParamNbrligne)
    {
        ProgressBarBonLivraisonClt.setVisible(true);
        
        ButtonSearchBonLivraisonClt.setDisable(true);
        
        ThreadSearchBonLivraisonClt = new Service<Void>(){
            @Override
            protected Task<Void> createTask(){
                return new Task<Void>(){
                    @Override
                    protected Void call() throws Exception{
                        
                        String DateLivraison = "";
                        if(DatePickerDateLivraison.getValue() != null){
                            DateLivraison = DatePickerDateLivraison.getValue().toString();
                        }
                        
                        ObservableList<BonLivraisonCltGestionList> ListBonLivraisonClts = new BonLivraisonCltDB().SearchBonLivraisonCltGestion(ParmPosition, ParamNbrligne, TextFieldIdBonLivrasionClt.getText(), DateLivraison, TextFieldCodeClt.getText(), TextFieldIdFactureClt.getText(), TextFieldTransporteur.getText(), TextFieldAdresseLivraison.getText());
                        
                        TableViewBonLivraisonCltListGestion.setItems(ListBonLivraisonClts);
                        
                        return null;
                    }
                };
            }
	};
        
        ThreadSearchBonLivraisonClt.setOnSucceeded(new EventHandler<WorkerStateEvent>(){
            @Override
            public void handle(WorkerStateEvent event){
                ProgressBarBonLivraisonClt.setVisible(false);
                ButtonSearchBonLivraisonClt.setDisable(false);
            }
        });
        ThreadSearchBonLivraisonClt.start();
    }
  
    private void GestionSearchBonLivraisonClt()
    {
        NbrLigne.getSelectionModel().selectedIndexProperty().addListener(new ChangeListener<Number>() {

            public void changed(ObservableValue ov,  Number value, Number new_value) {
                nbrligne= Integer.parseInt((String) cursors.get(new_value.intValue()));
                if(totalcount % nbrligne==0){ nbrpage = totalcount / nbrligne ;}
                else{ nbrpage = (totalcount / nbrligne) + 1 ; }
                NbrPage.setText(Integer.toString(nbrpage));
                position=0;
                ActuellePage.setText("1");
                actuellepage=1;
                NextLastSearchBonLivraisonClt(position, nbrligne);
            }
        });

        if(totalcount % nbrligne==0){ nbrpage = totalcount / nbrligne ;}
        else{ nbrpage = (totalcount / nbrligne) + 1 ; }
        NbrPage.setText(Integer.toString(nbrpage));


        //next page
        nextgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage<nbrpage)
                {
                    position=position+nbrligne;
                    NextLastSearchBonLivraisonClt(position, nbrligne);
                    actuellepage=actuellepage+1 ;
                    ActuellePage.setText(Integer.toString(actuellepage));

                }
            }
        }); 

        //last page
        lastgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage>1)
                {
                    position=position-nbrligne;
                    NextLastSearchBonLivraisonClt(position, nbrligne);
                    actuellepage=actuellepage-1 ;
                    ActuellePage.setText(Integer.toString(actuellepage));
                }
            }
        }); 

        //next page avec pas de 5
        avancergroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage+3<nbrpage)
                {
                    position=(position+4)+nbrligne;
                    NextLastSearchBonLivraisonClt(position, nbrligne);
                    actuellepage=actuellepage+3 ;
                    ActuellePage.setText(Integer.toString(actuellepage));

                }
            }
        });

        //last page avec un pas de -5
        retourgroupe.setOnMousePressed(new EventHandler<MouseEvent>(){
            @Override
            public void handle(MouseEvent event) {
                if(actuellepage-3>1){
                    position=(position-4)-nbrligne;
                    NextLastSearchBonLivraisonClt(position, nbrligne);
                    actuellepage=actuellepage-3 ;
                    ActuellePage.setText(Integer.toString(actuellepage));
                }
            }
        });

    }
}
